uses VarSubstUnit, RelToAbsPathUnit;
{$INCLUDE poigarmin.config.pas}
{$INCLUDE poigarmin.varsubst.lib.pas}

const
   BUNDLED_TEMPLATES_DIR = 'templates_bundled';
   DEFAULT_TEMPLATES_DIR = 'templates';
   
function GetBundledTemplatesFolder : String;
begin
  Result := RelToAbsPath(BUNDLED_TEMPLATES_DIR,GetRunningScriptDir);
end;

function GetDefaultTemplatesFolder : String;
begin
  Result := RelToAbsPath(DEFAULT_TEMPLATES_DIR,GetRunningScriptDir);
end;

function SafelyCopyFile(source,destination : String) : boolean;
begin
   Result := false;
   if ((FileExists(source)) and (not FileExists(destination)))then Result := CopyFile(source,destination);
end;

function GetFilenameFromPath(filename : String) : String;
begin
    Result := RegexExtract('[^\\]+$',filename);
end;

function EndsWith(str,ch : String) : boolean;
begin
    Result := (copy(str,length(str),1) = ch);
end;

function GetLastFolderName(filename : String) : String;
begin
    Result := RegExSubstitute('\\([^\\]+)\\$', filename, '$1');
end;

procedure SafelyCopyTree(sourceDir,destDir : String);
var
  list : TStringList;
  n: Integer;
begin
   if not EndsWith(sourceDir,'\') then sourceDir := sourceDir + '\';
   if not EndsWith(destDir,'\') then destDir := destDir + '\';
   if not DirectoryExists(destDir) then ForceDirectories(destDir);
   
   list := TStringList.Create;
   try
      Filelist(sourceDir,list);
      for n := 0 to list.count-1 do
      begin
          if EndsWith(list[n],'\') 
            then SafelyCopyTree(list[n],destDir + GetLastFolderName(list[n]))
            else SafelyCopyFile(list[n],destDir + GetFilenameFromPath(list[n]));
      end;
   finally
      list.Free;
   end;
end;

function InstallWork: String;
var 
  lang,langdir: String;
begin
   //init
   Result := '';
   
   //zjisteni jazyka a urceni zdrojove slozky se sablonami
   lang := copy(GetCurrentLanguage,1,2);
   langdir := GetBundledTemplatesFolder + lang + '\';
   if (not DirectoryExists(langdir)) then langdir := GetBundledTemplatesFolder + 'en\';

   //zkopirovani souboru sablon - neprepisujeme uzivatelske sablony!
   SafelyCopyTree(langdir,GetDefaultTemplatesFolder);
end;